'''
tools for LMSmusly
(c) 2017 R.S.U. / GPL v3 / https://www.nexus0.net/pub/sw/lmsmusly
'''

import re, sqlite3, logging, os
from lmsmusly.utils import config

_LOGGER = logging.getLogger(__name__)

def db_init( scursor):
	scursor.execute('''CREATE TABLE IF NOT EXISTS tracks (
		id INTEGER PRIMARY KEY AUTOINCREMENT,
		file varchar UNIQUE NOT NULL,
		vals blob NOT NULL)''')
	scursor.execute('''CREATE TABLE IF NOT EXISTS jukebox (
		id INTEGER PRIMARY KEY AUTOINCREMENT,
		method varchar NOT NULL,
		player varchar UNIQUE NOT NULL,
		boxsize integer NOT NULL,
		boxbin blob NOT NULL)''')
	scursor.execute('CREATE UNIQUE INDEX IF NOT EXISTS tracks_idx ON tracks( file)')
#	scursor.execute('DELETE FROM tracks')

def get_files_dir( fpath):
	fpatt = re.compile( config.MFILEPATTERN, re.IGNORECASE)
	allfiles = []

	for root, dirs, filenames in os.walk( fpath):
		for f in filenames:
			if fpatt.match( f):
				allfiles.append( os.path.join(root, f))

	_LOGGER.debug( "get_files_dir: {} files from {}".format( len(allfiles), fpath))
	return allfiles

def get_files_inputfile( ifile):
	allfiles = []
	fpatt = re.compile( '^#.*')

	with open( ifile, 'r') as fp:
		for line in fp:
			if not fpatt.match( line):
				allfiles.append( line.strip())
		fp.close()

	_LOGGER.debug( "get_files_inputfile: {} files from {}".format( len(allfiles), ifile))
	return allfiles